package nl.tudelft.ewi.es.mbdlistener.diagnoser;

import java.util.Iterator;
import java.util.SortedSet;
import java.util.TreeSet;


public class Diagnosis implements Comparable<Diagnosis> {
	private SortedSet<Environment> diagnosis ;

	public Diagnosis(SortedSet<Environment> diagnosis) {
		this.diagnosis = new TreeSet<Environment>(diagnosis); 
	}
	
	public Diagnosis(Environment environment) {
		this.diagnosis = new TreeSet<Environment>();
		this.diagnosis.add(environment);
	}
	
	public Diagnosis() {
		this.diagnosis = new TreeSet<Environment>();
	}

	public SortedSet<Environment> getDiagnosis() {
		return diagnosis;
	}
	
	@Override
	public String toString() {
		String retval = "[";  
		for (Environment env : diagnosis) {
			retval += env + ", ";
		}
		if(!diagnosis.isEmpty())
			retval = retval.substring(0, retval.length()-2);
		return retval + "]";
	}
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Diagnosis) {
			Diagnosis diagObj = (Diagnosis) obj;
			return diagnosis.equals(diagObj.getDiagnosis());
		}
		// TODO Auto-generated method stub
		return super.equals(obj);
	}

	public boolean supersetOf(Diagnosis otherDiag) {
		return this.diagnosis.containsAll(otherDiag.getDiagnosis());
	}
	
	@Override
	public int compareTo(Diagnosis o) {
		double ownvalue =0.0;
		for (Environment env : diagnosis){
			if (env instanceof LinkEnvironment){
				ownvalue += 0.5;
			}
			else 
				ownvalue += 1;
		}

		double othervalue =0.0;
		for (Environment env : o.getDiagnosis()){
			if (env instanceof LinkEnvironment){
				othervalue += 0.5;
			}
			else 
				othervalue += 1;
		}
		if (othervalue > ownvalue)
			return -1;
		if (ownvalue > othervalue)
			return 1;
		
		
		if (o.getDiagnosis().size() > diagnosis.size())
			return -1;
		if (o.getDiagnosis().size() < diagnosis.size())
			return 1;
		
		Iterator<Environment> thisIterator = diagnosis.iterator();
		Iterator<Environment> otherIterator = o.getDiagnosis().iterator();
		
		for (int i=0; i<diagnosis.size(); i++) {
			int val = thisIterator.next().compareTo(otherIterator.next());
			if (val != 0)
				return val;
		}
		
		return 0;
	}

	public void add(Environment env) {
		diagnosis.add(env);
	}
}
