package nl.tudelft.ewi.es.mbdlistener.graphics;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;


public class Node {
	private float x;
	private float y;
	private int nodeId;
	private boolean isFaulty;
	private boolean isSensorFaulty;
	
	public Node(int nodeId, float d, float e) {
		this.x = d;
		this.y = e;
		this.nodeId = nodeId;
		this.isFaulty = false;
		this.isSensorFaulty = false;
	}

	/**
	 * @return the x
	 */
	public double getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public double getY() {
		return y;
	}

	/**
	 * @return the nodeId
	 */
	public int getNodeId() {
		return nodeId;
	}
	
	public void setFaulty(boolean isFaulty) {
		this.isFaulty = isFaulty;
	}
	
	public boolean isFaulty() {
		return isFaulty;
	}
	public boolean isSensorFaulty() {
		return isSensorFaulty;
	}
	public void setSensorFaulty(boolean isSensorFaulty) {
		this.isSensorFaulty = isSensorFaulty;
	}
	public void paintNode(Graphics2D g2, double scale) {
		if (isFaulty && isSensorFaulty)
			g2.setColor(Color.PINK);
		else if(isFaulty)
			g2.setColor(Color.RED);
		else if(isSensorFaulty)
			g2.setColor(Color.GREEN);
		
		g2.setFont(new Font(g2.getFont().getName(), g2.getFont().getStyle(), (int)(20/scale)));
		g2.fill(new Ellipse2D.Float(x,y,(float)(20/scale),(float)(20/scale)));
        g2.drawString(String.valueOf(nodeId), x, y);
		g2.setColor(Color.BLACK);
	}
}
