package nl.tudelft.ewi.es.mbdlistener.types;

import java.io.Serializable;

/**
 * @author Adriaan de Jong
 * 
 * @param <T1>
 * @param <T2>
 */
public class Tuple<T1, T2> implements Serializable {
	private static final long serialVersionUID = -9013598541067805457L;
	private T1 var1;
	private T2 var2;

	public Tuple(T1 var1, T2 var2) {
		this.var1 = var1;
		this.var2 = var2;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Tuple))
			return false;
		final Tuple<?, ?> other = (Tuple<?, ?>) obj;
		if (var1 == null) {
			if (other.var1 != null)
				return false;
		} else if (!var1.equals(other.var1))
			return false;
		if (var2 == null) {
			if (other.var2 != null)
				return false;
		} else if (!var2.equals(other.var2))
			return false;
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((var1 == null) ? 0 : var1.hashCode());
		result = prime * result + ((var2 == null) ? 0 : var2.hashCode());
		return result;
	}

	@Override
	public String toString() {
		return "<" + var1 + ", " + var2 + ">";
	}

	public T1 var1() {
		return var1;
	}

	public T2 var2() {
		return var2;
	}
}
