/**
 * @author Adriaan de Jong
 */

#ifndef INFERENCE_ENGINE_H
#define INFERENCE_ENGINE_H


enum {
	// The size of the prediction queue, when processing an observation
	PRED_QUEUE_SIZE = 20,
	// The size of the data store, which contains rules, observations, and predictions
	DATA_HEAP_SIZE = 512,
	// The Observation ID database size, maps (observation_type,parameters) to local 8 bit IDs
	OBS_IDDB_SIZE = 260,
	// The Environment ID database size, maps (observation_type,parameters) to local 8 bit IDs
	ENV_IDDB_SIZE = 200,
	// For approximation of sensor values, a neighbouring value must lie between value-APPROX_MAX_DIFFERENCE and value+APPROX_MAX_DIFFERENCE
	APPROX_MAX_DIFFERENCE = 6
};

#endif

