#ifndef OBSERVATION_H
#define OBSERVATION_H

#define OBS_TYPE "ObservationType"

typedef uint8_t observation_id_t;

enum {
	OBS_TYPE_NONE = unique(OBS_TYPE),
	OBS_TYPE_SEND = unique(OBS_TYPE),
	OBS_TYPE_RECEIVE = unique(OBS_TYPE),
	OBS_TYPE_SENSOR_VALUE = unique(OBS_TYPE),
	OBS_TYPE_APPROX_SENSOR_VALUE = unique(OBS_TYPE),
	OBS_TYPE_COUNT = uniqueCount(OBS_TYPE)
};

typedef struct obs_params_send_recv {
    am_addr_t sender;
    am_addr_t receiver;
} obs_params_send_recv_t;

typedef struct obs_params_sensor_value {
    am_addr_t node_id;
} obs_params_sensor_value_t;

typedef struct obs_info {
	size_t params_size;
	size_t value_size;
} obs_info_t;

obs_info_t const obs_info[5] =
{
		{0},
		{sizeof(obs_params_send_recv_t), sizeof(bool)},
		{sizeof(obs_params_send_recv_t), sizeof(bool)},
		{sizeof(obs_params_sensor_value_t), sizeof(uint16_t)},
		{sizeof(obs_params_sensor_value_t), sizeof(uint16_t)}
};

#endif
