#!/bin/bash
# Simulator harness: 
# 1) Enters the directory results/config_<num>, as defined in CONFIGS,
# and compiles the simulator with the TestMbd.h file placed there.
# 2) Iterates through the scenarios specified in SCENARIOS,  and copies
# their config files from the config/ directory to the directory for
# the run.
# 3) runs the simulator, for every run defined in RUNS, and outputs data
# to results/config_<num>/<scenario>_<run>_*.out
#
# This system is currently rather fragile, and should be toughened for
# any serious use.


#RUNS="0 1 2 3 4 5"
CONFIGS="0"
#TESTS = "noisy1 idealised noisy2 noisy_dense"
#TESTS="noisy3 noisy4"
SCENARIOS="idealised noisy2 noisy3 noisy4 noisy5 noisy6 noisy_dense"
RUNS="6 7 8 9 10"

START_DIR=`pwd`

for CONFIG in $CONFIGS ; do
    cp results/config_${CONFIG}/TestMbd.h ../node_image
    pushd ../node_image
    echo "Compiling configuration ${CONFIG}"
    make clean > ${START_DIR}/results/config_${CONFIG}/Compiler.out 
    make micaz sim-sf >> ${START_DIR}/results/config_${CONFIG}/Compiler.out
    popd
    for SCENARIO in ${SCENARIOS} ; do
	for RUN in $RUNS; do
	    echo "Running ${SCENARIO} ${RUN}"
	    cp scenarios/${SCENARIO}_*.out results/config_${CONFIG}/
	    ./run_scenario.py results/config_${CONFIG}/${SCENARIO} ${RUN} | tee results/config_${CONFIG}/${SCENARIO}_${RUN}_stdout.out |grep -v "Tree sent beacon"
	done
    done
done

echo "Done!!!!!"
