#!/usr/bin/env python
from tinyos.tossim.TossimApp import *
from TOSSIM import *
import sys

num_nodes = 49;

def loadNoiseDummy(tossim, nodes, level):
    for i in range(0, nodes):
        print "Creating noise model for ", i;
	for j in range(0,100):
	    t.getNode(i).addNoiseTraceReading(level)
        t.getNode(i).createNoiseModel()

def loadNoiseMeyerHeavy(tossim, nodes):
    noise = open("meyer-heavy.txt", "r")
    lines = noise.readlines()
    for line in lines:
        str = line.strip()
        if (str != ""):
            val = int(str)
            for i in range(0, num_nodes):
                t.getNode(i).addNoiseTraceReading(val)

    for i in range(0, nodes):
        print "Creating noise model for ",i;
        t.getNode(i).createNoiseModel()

def loadTopo(radio):
    f = open("topo.txt", "r")

    lines = f.readlines()
    for line in lines:
        s = line.split()
        if (len(s) > 0):
            print " ", s[0], "->", s[1], " ", s[2];
            r.add(int(s[0]), int(s[1]), float(s[2]))

def loadGainTopo(filename, radio,t):
    f = open(filename, "r")

    lines = f.readlines()
    for line in lines:
        s = line.split()
        if (len(s) > 0):
	    if (s[0] == "gain"):
    		print " ", s[1], "->", s[2], " ", s[3];
        	radio.add(int(s[1]), int(s[2]), float(s[3]))

def loadNoiseTopo(filename, radio,t):    
    f = open(filename, "r")
    
    lines = f.readlines()
    for line in lines:
        s = line.split()
        if (len(s) > 0):
	    if (s[0] == "noise"):
	        print "Creating noise model for ", s[1], "@" + s[2];
		for j in range(0,100):
        	    t.getNode(int(s[1])).addNoiseTraceReading(int(float(s[2])))
	        t.getNode(int(s[1])).createNoiseModel()

def loadSim(t, sf):
    
#    loadTopo(r)
#    loadGainTopo("linkgain.out", r)
#    loadGainTopo("config/idealised_linkgain.out", r)
#    loadNoiseTopo("config/idealised_linkgain.out", r)
#    loadNoiseTopo("linkgain.out", r)
#    loadNoiseDummy(t, num_nodes, -110)
#    loadNoiseMeyerHeavy(t, 4)
    
    for i in range(0,num_nodes):
        t.getNode(i).bootAtTime(12321 * i + 165241);

    sf.process();

    ##### Get some output

    # TestMBD
    t.addChannel("Boot", sys.stdout);
#    t.addChannel("InferenceEngineC", sys.stdout);
    t.addChannel("ModelC", sys.stdout);
    t.addChannel("SymptomC", sys.stdout);
    t.addChannel("ObservationC", sys.stdout);
    t.addChannel("RuleC", sys.stdout);
    t.addChannel("EnvironmentC", sys.stdout);
    t.addChannel("InferenceEngineC", sys.stdout);
#    t.addChannel("InferenceEngineDebug", sys.stdout);
    t.addChannel("TestMbdC", sys.stdout);
#    t.addChannel("TestMbdCRoot", sys.stdout);
#    t.addChannel("TestMbdCNode", sys.stdout);
#    t.addChannel("TestMbdCOverhear", sys.stdout);
    #t.addChannel("TestMbdCSendReceive", sys.stdout);

    # Leds
    #t.addChannel("LedsC", sys.stdout);
    
    # CTP
#    t.addChannel("Forwarder", sys.stdout);
    #t.addChannel("Route", sys.stdout);
    #t.addChannel("LITest", sys.stdout);
    #t.addChannel("Cache", sys.stdout);
    #t.addChannel("RoutingTimer", sys.stdout);
    #t.addChannel("TreeRoutingCtl", sys.stdout);
#    t.addChannel("TreeRouting", sys.stdout);



from DebugMessage import *
from tinyos.message import MoteIF

class DebugListener:
    def __init__(self, msgout):
	self.msgout = msgout
        # Create a MoteIF
        self.mif = MoteIF.MoteIF()
        # Attach a source to it
        self.source = self.mif.addSource("sf@localhost:9002")

        # SomeMessageClass.py would be generated by MIG
        self.mif.addListener(self, DebugMessage)

    # Called by the MoteIF's receive thread when a new message
    # is received
    def receive(self, src, msg):
	if msg.get_type() == 1:
	    if msg.get_data1() == 0:
        	print t.time(), "(" + str(msg.getAddr()) + ")", "Node dying at", msg.get_data2()
	    if msg.get_data1() == 1:
        	print t.time(), "(" + str(msg.getAddr()) + ")", "Node dying now!"
        elif msg.get_type() == 5:
	    print t.time(), "(" + str(msg.getAddr()) + ")", "Tree sent beacon"
	elif msg.get_type() == 7:
	    print t.time(), "(" + str(msg.getAddr()) + ")", "Node sent or intercepted conflict!"
	    print >>self.msgout, t.time(), msg.getAddr(), msg.get_data1(), 1
	    self.msgout.flush()
        else :
            print t.time(), msg.get_type(), msg.get_data1(), msg.get_data2(), msg.get_data3(), msg.get_data4()

from SerialConflictMessage import *
class ConflictListener:
    def __init__(self, conflictout, rawconflictout):
	self.conflictout = conflictout
	self.rawconflictout = rawconflictout
        # Create a MoteIF
        self.mif = MoteIF.MoteIF()
        # Attach a source to it
        self.source = self.mif.addSource("sf@localhost:9002")

        # SomeMessageClass.py would be generated by MIG
        self.mif.addListener(self, SerialConflictMessage)

    # Called by the MoteIF's receive thread when a new message
    # is received
    def receive(self, src, msg):
        print t.time(), msg
        print >>self.conflictout, t.time(), msg
        print >>self.rawconflictout, t.time(), msg.data
        self.conflictout.flush()
        self.rawconflictout.flush()
        

def doRun (prefix, run, sf):
#    global sf, r, t, simstep
    global t
    msgout = open(prefix +  "_" + str(run) +"_msgs.out", "w");
    conflictout = open(prefix + "_" + str(run) +"_conflict.out", "w");
    rawconflictout = open(prefix + "_" + str(run) +"_rawconflict.out", "w");
    simstep = 0

    t = Tossim([])
    r = t.radio()
    dbgListen = DebugListener(msgout)
    conflictListen = ConflictListener(conflictout, rawconflictout)
    loadGainTopo(prefix+"_linkgain.out", r, t)
    loadNoiseTopo(prefix+"_linkgain.out", r, t)
    loadSim(t, sf);

    ### Run simulation
#    for simstep in range(0, 8000000):
    while t.time() / t.ticksPerSecond() < 3600:
        t.runNextEvent()
        sf.process();

if __name__ == '__main__':
    print "\n\n\nStarting run", sys.argv[1], "part", sys.argv[2]
    sf = SerialForwarder(9002)
    doRun(sys.argv[1], int(sys.argv[2]), sf);
    sys.exit(0);
