#!/usr/bin/gnuplot -persist

#plot "<cat  Time.plot.plot| gethistogram 100 1" u 1:2 t 'data' w histeps
#plot "<cat  Time.plot.plot| gethistogram 10 1" u 1:2 t 'data' w steps
#plot "<cat  Time_idealised.plot.plot| gethistogram 10 0 1" u 1:2 w steps title "idealised"
#replot "<cat  Time_noisy1.plot.plot| gethistogram 10 0 1" u 1:2 w steps title "noisy1"
#replot "<cat  Time_noisy2.plot| gethistogram 10 0 1" u 1:2 w steps title "noisy2"
#replot "<cat  Time_noisy_dense.plot| gethistogram 10 0 1" u 1:2 w steps title "noisy dense"

set xlabel "Detection time (s)"
set style data histogram
set style histogram cluster gap 2
set style fill solid border -1
set boxwidth 0.9
#set xtic rotate by -45 scale 0
set size 0.75,0.75

set terminal postscript eps enhanced color
set output "sensor_failure_detection.eps"

#set title "Time until a sensor failure was detected"
set ylabel "Number of detected sensors"
set yrange [0:41]
plot "<cat  Time_idealised.plot| gethistogram 5 0" u 2:xtic(1) title "Grid", \
	"<cat  Time_noisy3.plot| gethistogram 5 0" u 2  title "Normal 1",\
	"<cat  Time_noisy4.plot| gethistogram 5 0" u 2  title "Normal 2",\
	"<cat  Time_noisy5.plot| gethistogram 5 0" u 2  title "Normal 3",\
	"<cat  Time_noisy6.plot| gethistogram 5 0" u 2  title "Normal 4",\
	"<cat  Time_noisy2.plot| gethistogram 5 0" u 2  title "Noisy",\
	"<cat  Time_noisy_dense.plot| gethistogram 5 0" u 2:xtic(1)  title "Dense",\
	 "<cat  Time_testbed.plot| gethistogram 5 0 " u 2:xtic(1)  title "Testbed" lt rgb "forest-green"

set output "node_failure_detection.eps"

#set title "Time until a node failure was detected"
set ylabel "Node crashes detected over 10 runs (%)"
set yrange [0:103]
plot "<cat  Time_idealised.plot| gethistogram 100 1|grep -v '\"100 - 200\" 0'|grep -v '\"0 - 100\" 0'" u ($2*100/30):xtic(1) title "Grid" lt rgb "red", \
	"<cat  Time_noisy3.plot Time_noisy4.plot Time_noisy5.plot Time_noisy6.plot| gethistogram 100 1|grep -v '\"100 - 200\" 0'|grep -v '\"0 - 100\" 0'" u ($2*100/120)  title "Normal" lt rgb "blue",\
	"<cat  Time_noisy_dense.plot| gethistogram 100 1|grep -v '\"100 - 200\" 0'|grep -v '\"0 - 100\" 0'" u ($2*100/30)  title "Dense" lt rgb "black",\
	"<cat  Time_testbed.plot| gethistogram 100 1|grep -v '\"100 - 200\" 0'|grep -v '\"0 - 100\" 0' " u ($2*100/30)  title "Testbed"  lt rgb "forest-green"

#	"<cat  Time_noisy4.plot| gethistogram 50 1" u 2  title "Normal 2",\
#	"<cat  Time_noisy5.plot| gethistogram 50 1" u 2  title "Normal 3",\
#	"<cat  Time_noisy6.plot| gethistogram 50 1" u 2  title "Normal 4",\
#	"<cat  Time_noisy2.plot| gethistogram 50 1" u 2  title "Noisy",\

set output "sensor_false_positives.eps"

set title "Time sensor false positives existed"
set ylabel "Number of detected false positives"
set yrange [0:49]
plot "<cat  Time_idealised.plot| gethistogram 25 2" u 2:xtic(1) title "Grid", \
	"<cat  Time_noisy3.plot| gethistogram 25 2" u 2  title "Normal 1",\
	"<cat  Time_noisy4.plot| gethistogram 25 2" u 2  title "Normal 2",\
	"<cat  Time_noisy5.plot| gethistogram 25 2" u 2  title "Normal 3",\
	"<cat  Time_noisy6.plot| gethistogram 25 2" u 2  title "Normal 4",\
	"<cat  Time_noisy2.plot| gethistogram 25 2" u 2:xtic(1)  title "Noisy",\
	"<cat  Time_noisy_dense.plot| gethistogram 25 2" u 2:xtic(1)  title "Dense",\
	 "<cat  Time_testbed.plot| gethistogram 25 2 " u 2  title "Testbed" lt rgb "forest-green"

set output "node_false_positives.eps"

set title "Time node false positives existed"
set ylabel "Number of detected false positives"
set yrange [0:3]
plot "<cat  Time_idealised.plot| gethistogram 50 3" u 2:xtic(1) title "Grid", \
	"<cat  Time_noisy3.plot| gethistogram 50 3" u 2  title "Normal 1",\
	"<cat  Time_noisy4.plot| gethistogram 50 3" u 2:xtic(1)  title "Normal 2",\
	"<cat  Time_noisy5.plot| gethistogram 50 3" u 2  title "Normal 3",\
	"<cat  Time_noisy6.plot| gethistogram 50 3" u 2  title "Normal 4",\
	"<cat  Time_noisy2.plot| gethistogram 50 3" u 2  title "Noisy",\
	"<cat  Time_noisy_dense.plot| gethistogram 50 3" u 2  title "Dense",\
	"<cat  Time_testbed.plot| gethistogram 50 3 " u 2  title "Testbed"

#set output "run_messages.eps"

#set title "Number of messages per run"
#set ylabel "Number of detected false positives"
#plot "<cat  run_0_idealised_msg.plot| gethistogram 50 1" u 2:xtic(1) title "Grid", \
#	"<cat  run_0_noisy3_msg.plot| gethistogram 50 1" u 2  title "Normal 1",\
#	"<cat  run_0_noisy4_msg.plot| gethistogram 50 1" u 2:xtic(1)  title "Normal 2",\
#	"<cat  run_0_noisy5_msg.plot| gethistogram 50 1" u 2  title "Normal 3",\
#	"<cat  run_0_noisy6_msg.plot| gethistogram 50 1" u 2  title "Normal 4",\
#	"<cat  run_0_noisy2_msg.plot| gethistogram 50 1" u 2  title "Noisy",\
#	"<cat  run_0_noisy_dense_msg.plot| gethistogram 50 1" u 2  title "Dense"
#	"<cat  run_0_testbed_msg.plot| gethistogram 50 3 " u 2  title "Testbed"
